#!/bin/sh

PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:$PATH"
PORTAL="$1"
TARGET="$2"
LOG="/dev/null"

#QNAP fix
if [ -e /etc/config/qpkg.conf ]; then
    PORTAL=`echo $PORTAL | sed '/\([^:]*\):\(.*\)/s//[\1]:\2/'`
elif [ -x '/usr/bin/iscsictl' ]; then
    #BSD tools
    ISCSI_CTL='/usr/bin/iscsictl'
fi

if [ "x${ISCSI_CTL}" != "x" ]; then
    $ISCSI_CTL -R -p "$PORTAL" -t "$TARGET" >>"$LOG" 2>&1
else
    iscsiadm -m node -p "$PORTAL" -T "$TARGET" -u >>"$LOG" 2>&1
    iscsiadm -m node -p "$PORTAL" -T "$TARGET" -o delete >>"$LOG" 2>&1
    if [ $? -ne 0 ]; then
        ADDRESS=`echo $PORTAL | cut -d ':' -f 1`
        PORT=`echo $PORTAL | cut -d ':' -f 2`
        if [ -d "/etc/iscsi/send_targets/${ADDRESS},${PORT}" ]; then
            find "/etc/iscsi/send_targets/${ADDRESS},${PORT}" -name "$TARGET,${ADDRESS},${PORT},${PORT},*" -delete >>"$LOG" 2>&1
        fi
        [ -d "/etc/iscsi/nodes/$TARGET" ] && rm -rf "/etc/iscsi/nodes/$TARGET" >>"$LOG" 2>&1
    fi
fi

exit 0
