#!/bin/sh

PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:$PATH"
LOG="/dev/null"

case "${1:-missing}" in
    "resolve")
        PROTO=`echo $2 | cut -d ':' -f 1`
        ADDRESS=`echo $2 | cut -d ':' -f 2- | sed -n '/^\[\([^]]*\)\]$/s//\1/p'`
        if [ "x${ADDRESS}" != "x" ]; then
            DEVICE=$(ls -la /sys/block/*/device | grep -E "/$ADDRESS/?$" | sed -n '\@.*/sys/block/\([^/]*\)/.*@s@@\1@p')
        fi

        if [ "x${DEVICE}" != "x" ]; then
            echo "/dev/$DEVICE"
        else
            exit 1
        fi
    ;;
    "id")
        OLD_IFS="$IFS"
        IFS=':'
        for PREFIX in $PATH; do
            if [ -x "$PREFIX/dmidecode" ]; then
                $PREFIX/dmidecode -t 1 2>/dev/null | sed -n '/[[:space:]]*Serial Number: \(.*\)$/s//\1/p'
                break
            fi
        done
        IFS="$OLD_IFS"
    ;;
    *)
        echo "Unknown command: $1"  >"$LOG"
        exit 100
    ;;
esac

exit 0
